package com.sun.beans.editors;

import java.beans.PropertyEditorSupport;

public class BooleanEditor extends PropertyEditorSupport
{
    public BooleanEditor() {
    }
    
    @Override
    public String getJavaInitializationString() {
        Object value = this.getValue();
        return (value != null) ? value.toString() : "null";
    }
    
    @Override
    public String getAsText() {
        Object value = this.getValue();
        return (value instanceof Boolean) ? this.getValidName((boolean)value) : null;
    }
    
    @Override
    public void setAsText(String s) throws IllegalArgumentException {
        if (s == null) {
            this.setValue(null);
        }
        else if (this.isValidName(true, s)) {
            this.setValue(Boolean.TRUE);
        }
        else if (this.isValidName(false, s)) {
            this.setValue(Boolean.FALSE);
        }
        else {
            throw new IllegalArgumentException(s);
        }
    }
    
    @Override
    public String[] getTags() {
        return new String[] { this.getValidName(true), this.getValidName(false) };
    }
    
    private String getValidName(boolean b) {
        return b ? "True" : "False";
    }
    
    private boolean isValidName(boolean b, String anotherString) {
        return this.getValidName(b).equalsIgnoreCase(anotherString);
    }
}
